; VXDSOUND.ASM
; This source is very shoddy
; Error checking is neglected at every corner
; An occurrence of "SNOZZBERRY" is roughly equivalent to "TODO:"

.386p
include vmm.inc 
include vwin32.inc 
include shell.inc
include vtd.inc
include vdmad.inc
include vpicd.inc


; Size: 16 bytes
DMABlock        STRUC
        ValidDMAHandle  dd              ? ; Is handle valid?
        DMAHandle       dd              ? ; The DMA handle
        ExtendedMode    dd              ? ; The extended mode field
        Padding         dd              ? ; Some padding
DMABlock        ENDS

; Size: 56 bytes
IRQBlock        STRUC
        ValidIRQHandle  dd              ? ; Is handle valid?
        IsStolen        dd              ? ; Has the handle been stolen?
        IsMasked        dd              ? ; Has the IRQ been masked?
        IRQHandle       dd              ? ; The IRQ handle
        IRQDesc         VPICD_IRQ_Descriptor    <> ; IRQ Descriptor
        IRQCode         db              8 DUP (?) ; Code for the IRQ hook
IRQBlock        ENDS

; Size: 8 + 8 * DMABlockSize + 16 * IRQBlockSize
DataBlock       STRUC
        TerminalCnt1    db              ? ; For channels 0-3
        TerminalCnt2    db              ? ; For channels 4-7
        Masked1         db              ? ; For channels 0-3
        Masked2         db              ? ; For channels 4-7
        Padding1234     db              4 DUP (?)
        DMAHandles      DMABlock        8 DUP (<>) ; Array of handles
        IRQHandles      IRQBlock        16 DUP (<>) ; Array of handles
DataBlock       ENDS


DECLARE_VIRTUAL_DEVICE VXDSOUND,1,0,VXDSOUND_Control,UNDEFINED_DEVICE_ID,UNDEFINED_INIT_ORDER,DosProc,DosProc



Begin_control_dispatch VXDSOUND
        Control_Dispatch w32_DeviceIoControl,OnDeviceIoControl 
End_control_dispatch VXDSOUND



VxD_LOCKED_DATA_SEG 

        TotalOut        dd              0
        TotalIn         dd              0
        MyVMHandle      dd              0
        ThreadID        dd              0
        ThreadProc      dd              0
        ThreadSeg       dd              0
        Win32VM         dd              0
        CallParam       dd              0
        IsDone          db              0
        DMAChannel      db              0 ; Temporary register
        TempHandle      dd              0 ; Temporary register
        hSemaphore      dd              0
        hSemaphore2     dd              0

        MemBlock        dd              0

        ReturnByte      db              0

        RegisterByte    db              0
        TimerStatus     db              0
        AdLibTimer1     dd              0
        AdLibTimer2     dd              0
        Timer1Start     dd              0,0
        Timer2Start     dd              0,0

        CallThing       db              "brrrrrrz"
        CallParr        dd              0
        CallParr2       dd              0
        Acknowledge     dd              0
        BigCountTemp    dd              0
        BigCount        dd              0

VxD_LOCKED_DATA_ENDS



VxD_LOCKED_CODE_SEG 

BeginProc OnDeviceIoControl

        assume esi:ptr DIOCParams

        .if [esi].dwIoControlCode==DIOC_Open
                
                VMMCall _PageAllocate,<1,PG_SYS,0,0,0,100000h,0,\
                        PAGELOCKED OR PAGEZEROINIT>
                mov     MemBlock,eax
                ; SNOZZBERRY check for errors
                mov     ecx,0
                VMMCall Create_Semaphore
                mov     hSemaphore,eax
                mov     ecx,0
                VMMCall Create_Semaphore
                mov     hSemaphore2,eax
                xor     eax,eax
                clc

        .elseif [esi].dwIoControlCode==DIOC_CloseHandle

                ; SNOZZBERRY remove IO hooks and free DMA and IRQ handles
                VMMCall _PageFree,MemBlock,0
                xor     eax,eax
                mov     eax,hSemaphore
                VMMCall Destroy_Semaphore
                mov     eax,hSemaphore2
                VMMCall Destroy_Semaphore
                xor     eax,eax
                clc

        .elseif [esi].dwIoControlCode==1

                ; Get call parameter
                
                mov     eax,hSemaphore2
                mov     ecx,Block_Thread_Idle
                VMMCall Wait_Semaphore
                mov     Acknowledge,1
                mov     eax,CallParam
                mov     esi,[esi].lpvOutBuffer
                mov     dword ptr[esi],eax
                mov     CallParr,eax
                mov     CallParam,0

        .elseif [esi].dwIoControlCode==2

                ; Acknowledge finish

                mov     esi,[esi].lpvInBuffer
                mov     al,byte ptr[esi]
                mov     ReturnByte,al
                mov     IsDone,0ffh
                ;mov     ebx,MyVMHandle
                ;VMMCall Resume_VM
                ;mov     ebx,MyVMHandle
                ;VMMCall Wake_Up_VM
                mov     eax,hSemaphore
                VMMCall Signal_Semaphore_No_Switch

        .elseif [esi].dwIoControlCode==3

                ; Set thread ID
                
                mov     esi,[esi].lpvInBuffer
                mov     eax,dword ptr[esi]
                mov     ThreadProc,eax
                mov     eax,dword ptr[esi+04h]
                mov     ThreadSeg,eax
                VMMCall Get_Cur_Thread_Handle
                mov     ThreadID,edi
                VMMCall Get_Cur_VM_Handle
                mov     Win32VM,ebx

        .elseif [esi].dwIoControlCode==4

                ; Get/Set register
                                
                mov     ebx,MyVMHandle
                mov     ebp,[ebx].CB_Client_Pointer
                mov     ebx,[esi].lpvInBuffer
                mov     eax,dword ptr[ebx]
                add     ebp,dword ptr[ebx+08h]
                mov     cl,byte ptr[ebx+04h]
                .if eax==0
                        xor     edx,edx
                        .if cl==0
                                mov     edx,dword ptr[ebp]
                        .elseif cl==1
                                mov     dx,word ptr[ebp]
                        .elseif cl==2
                                mov     dl,byte ptr[ebp]
                        .endif
                        mov     ecx,edx
                        mov     edx,[esi].lpvOutBuffer
                        mov     dword ptr[edx],ecx
                .elseif eax==1
                        mov     edx,dword ptr[ebx+0ch]
                        .if cl==0
                                mov     dword ptr[ebp],edx
                        .elseif cl==1
                                mov     word ptr[ebp],dx
                        .elseif cl==2
                                mov     byte ptr[ebp],dl
                        .endif
                .endif

        .elseif [esi].dwIoControlCode==5

                ; Poke an interrupt
                
                mov     edx,MemBlock
                add     edx,8+sizeof DMAHandles
                assume  edx:ptr IRQBlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                mov     eax,sizeof IRQBlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax
                .if [edx].ValidIRQHandle!=0 ; Check if handle is valid
                        .if [edx].IsMasked==0 ; Check if IRQ has been masked
                                mov     eax,[edx].IRQHandle
                                mov     ebx,MyVMHandle
                                VxDCall VPICD_Set_Int_Request
                        .endif
                .else
                        ; SNOZZBERRY Display error message here
                .endif

        .elseif [esi].dwIoControlCode==6

                ; Get DMA state

                mov     edx,MemBlock
                add     edx,8
                assume  edx:ptr DMABlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                mov     DMAChannel,bl
                mov     eax,sizeof DMABlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax

                .if [edx].ValidDMAHandle==1                        
                        mov     eax,[edx].DMAHandle
                        mov     ebx,MyVMHandle
                        mov     edi,dword ptr[esi+04h]
                        push    edi
                        push    edx
                        VxDCall VDMAD_Get_Virt_State
                        pop     ebx
                        assume  ebx:ptr DMABlock
                        mov     byte ptr[ebx].ExtendedMode,dh
                        pop     edi

                        mov     ebx,MyVMHandle
                        assume  ebx:ptr cb_s
                        sub     esi,[ebx].CB_High_Linear
                        mov     word ptr[edi],si ; addr
                        shr     esi,16
                        ; SNOZZBERRY should check for ECX > 65535
                        dec     cx
                        mov     word ptr[edi+02h],cx ; count
                        mov     word ptr[edi+04h],si ; page

                        ; Now since bits 4-7 of status are REQx bits, get
                        ; requested from DL and place it in bits 4-7 of
                        ; status according to DMAChannel
                        mov     cl,DMAChannel    ; CL = DMA channel
                        mov     bl,dl            ; get "mode" from DL
                        and     bl,DMA_requested ; mask in "requested" bit

                        .if cl < 4
                                add     cl,3
                                shl     bl,cl            ; Shift to bits 4-7
                                or      bl,TerminalCnt1  ; For compatibility
                        .else
                                dec     cl               ; Combination of sub cl,4 and add cl,3
                                shl     bl,cl            ; Shift to bits 4-7
                                or      bl,TerminalCnt2  ; For compatibility
                        .endif
                        mov     byte ptr[edi+06h],bl ; status
        
                        mov     bl,dl
                        and     bl,0fch ; Mask out DMA_Masked and DMA_Requested
                        .if DMAChannel < 4
                                add     bl,DMAChannel
                        .else
                                push    ecx
                                mov     cl,DMAChannel
                                and     cl,03h
                                add     bl,cl
                                pop     ecx
                        .endif
                        mov     byte ptr[edi+07h],bl ; mode

                        ; Bits 0-3 of mask are a mask of each channel
                        mov     bl,dl           ; get mode from DL and
                        and     bl,DMA_masked   ; mask in "masked" bit
                        mov     cl,DMAChannel   ; Prepare CL for shift left
                        mov     al,1            ; For mask
                        .if cl >= 4
                                sub     cl,4
                        .endif

                        shl     bl,cl   ; Put in respective bit
                        shl     al,cl   ; Shift mask
                        not     al      ; Flip mask
                        mov     edx,MemBlock
                        assume  edx:ptr DataBlock
                        .if DMAChannel < 4
                                and     [edx].Masked1,al
                                or      [edx].Masked1,bl ; Put into mask
                                mov     bl,[edx].Masked1
                        .else
                                and     [edx].Masked2,al
                                or      [edx].Masked2,bl
                                mov     bl,[edx].Masked2
                        .endif

                        mov     byte ptr[edi+08h],bl ; mask
                .else
                        ; SNOZZBERRY error: "tried to query non-hooked DMA
                        ; channel"
                .endif

        .elseif [esi].dwIoControlCode==7

                ; Set DMA state                

                mov     edx,MemBlock
                add     edx,8
                assume  edx:ptr DMABlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                mov     DMAChannel,bl
                mov     eax,sizeof DMABlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax
                mov     eax,[edx].DMAHandle
                mov     TempHandle,eax

                .if [edx].ValidDMAHandle==1
                        mov     ebx,edx
                        assume  ebx:ptr DMABlock
                        mov     edi,dword ptr[esi+04h]
                        mov     dh,byte ptr[ebx].ExtendedMode

                        mov     ebx,MyVMHandle
                        assume  ebx:ptr cb_s
                        mov     si,word ptr[edi+04h] ; page
                        shl     esi,16
                        mov     si,word ptr[edi] ; addr
                        add     esi,[ebx].CB_High_Linear

                        mov     bl,byte ptr[edi+06h] ; status
                        mov     cl,DMAChannel

                        .if cl < 4
                                add     cl,3
                                shr     bl,cl            ; Shift to bit 1
                        .else
                                dec     cl
                                shr     bl,cl            ; Shift to bit 1
                        .endif
                        mov     dl,bl ; Set DMA_requested bit

                        mov     bl,byte ptr[edi+06h] ; status (again)
                        mov     cl,DMAChannel
                        mov     al,1
                        .if cl < 4
                                sub     cl,4
                        .endif

                        shl     al,cl
                        and     bl,al   ; Mask in respective bit
                        not     al      ; Flip mask to mask out
                        push    edx
                        mov     edx,MemBlock
                        assume  edx:ptr DataBlock
                        .if DMAChannel > 4
                                and     [edx].TerminalCnt1,al
                                or      [edx].TerminalCnt1,bl
                        .else
                                and     [edx].TerminalCnt2,al
                                or      [edx].TerminalCnt2,bl
                        .endif
                        pop     edx

                        mov     bl,byte ptr[edi+07h] ; mode
                        and     bl,0fch ; Mask out DMA channel from mode
                        or      dl,bl ; Put it into mode

                        mov     bl,byte ptr[edi+08h] ; mask
                        mov     cl,DMAChannel
                        mov     al,1
                        .if cl < 4
                                sub     cl,4
                        .endif
                        shl     al,cl
                        and     bl,al   ; Mask in respective bit
                        .if bl!=0
                                or      dl,DMA_masked ; Set DMA_masked bit
                        .endif
                        not     al      ; Flip mask to mask out
                        push    edx
                        mov     edx,MemBlock
                        assume  edx:ptr DataBlock
                        .if DMAChannel > 4
                                and     [edx].Masked1,al
                                or      [edx].Masked1,bl
                        .else
                                and     [edx].Masked2,al
                                or      [edx].Masked2,bl
                        .endif
                        pop     edx

                        mov     eax,TempHandle
                        mov     ebx,MyVMHandle
                        movzx   ecx,word ptr[edi+02h] ; count
                        inc     ecx

                        VxDCall VDMAD_Set_Virt_State

                .else
                        ; SNOZZBERRY error: "tried to set non-hooked DMA
                        ; channel"
                .endif

        .elseif [esi].dwIoControlCode==8

                ; Install DMA hook

                mov     edx,MemBlock
                add     edx,8
                assume  edx:ptr DMABlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                mov     eax,sizeof DMABlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax

                .if [edx].ValidDMAHandle==0 ; If handle not taken
                        mov     eax,ebx ; DMA channel was in EBX
                        mov     esi,OFFSET32 DMAProc
                        push    eax
                        push    edx
                        VxDCall VDMAD_Virtualize_Channel
                        pop     edx
                        pop     ebx
                        jnc     ItWentFine

                        ; Try to "steal" the handle since function returns
                        ; EAX = DMA handle (undocumented)
                        push    ebx
                        push    edx
                        VxDCall VDMAD_Unvirtualize_Channel
                        pop     edx
                        pop     ebx
                        mov     eax,ebx
                        mov     esi,OFFSET32 DMAProc
                        push    edx
                        VxDCall VDMAD_Virtualize_Channel
                        pop     edx
                        jnc     ItWentFine

                        ; SNOZZBERRY display error message "DMA channel
                        ; could not be hooked"

                ItWentFine:
                        mov     [edx].DMAHandle,eax
                        mov     [edx].ValidDMAHandle,1
                        mov     ebx,MyVMHandle
                        ; SNOZZBERRY must set ExtendedMode
                .else
                        ; SNOZZBERRY display error message "tried to hook
                        ; DMA channel already hooked"
                .endif

        .elseif [esi].dwIoControlCode==9

                ; Install IO hooks
                
                mov     esi,[esi].lpvInBuffer
                mov     eax,dword ptr[esi+04h]
                mov     ebx,dword ptr[esi+08h]
        IOHookLoop:

                movzx   edx,word ptr[ebx] ; Start of range
                movzx   edi,word ptr[ebx+02h] ; End of range
        MultiIOLoop:
                VMMCall Remove_IO_Handler
                mov     esi,OFFSET32 IOProc
                VMMCall Install_IO_Handler
                cmp     edx,edi
                je      EndOfRange
                inc     edx
                jmp     MultiIOLoop

        EndOfRange:
                add     ebx,4
                dec     eax
                jnz     IOHookLoop

        .elseif [esi].dwIoControlCode==10

                ; Deinstall IO hook
                
                mov     esi,[esi].lpvInBuffer
                mov     eax,dword ptr[esi+04h]
                mov     ebx,dword ptr[esi+08h]
        IOHookLoop2:

                movzx   edx,word ptr[ebx] ; Start of range
                movzx   edi,word ptr[ebx+02h] ; End of range
        MultiIOLoop2:
                VMMCall Remove_IO_Handler
                cmp     edx,edi
                je      EndOfRange2
                inc     edx
                jmp     MultiIOLoop2

        EndOfRange2:
                add     ebx,4
                dec     eax
                jnz     IOHookLoop2

        .elseif [esi].dwIoControlCode==14

                ; Get V86 pointer
                
                mov     edi,[esi].lpvInBuffer
                mov     ebx,MyVMHandle
                mov     eax,[ebx].CB_High_Linear
                movzx   ebx,word ptr[edi+02h] ; segment
                shl     ebx,4
                add     eax,ebx
                movzx   ebx,word ptr[edi] ; offset
                add     eax,ebx
                mov     edi,[esi].lpvOutBuffer
                mov     dword ptr[edi],eax

        .elseif [esi].dwIoControlCode==15

                ; Unhook DMA

                mov     edx,MemBlock
                add     edx,8
                assume  edx:ptr DMABlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                push    ebx ; Save for later
                mov     eax,sizeof DMABlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax
                pop     eax ; Restore from before
                .if [edx].ValidDMAHandle==1
                        mov     [edx].ValidDMAHandle,0
                        mov     eax,[edx].DMAHandle
                        VxDCall VDMAD_Unvirtualize_Channel
                        ; SNOZZBERRY check for errors here
                .else
                        ; SNOZZBERRY display error message "tried to unhook
                        ; non-existent DMA handle"
                .endif

        .elseif [esi].dwIoControlCode==16

                ; Hook IRQ                

                mov     edx,MemBlock
                add     edx,8+sizeof DMAHandles
                assume  edx:ptr IRQBlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                push    ebx ; Save for later
                mov     eax,sizeof IRQBlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax
                pop     eax ; Restore from before

                cmp     [edx].ValidIRQHandle,1
                je      EndHookIRQ ; If it's already hooked don't hook it

                ; First method, simply try and call Virtualize_IRQ with
                ; VPICD_OPT_CAN_SHARE set.

                mov     [edx].IRQDesc.VID_IRQ_Number,ax
                mov     eax,edx
                add     eax,48
                mov     byte ptr[eax],090h     ; INT 3
                mov     byte ptr[eax+01h],0f9h ; STC
                mov     byte ptr[eax+02h],0c3h ; RET
                mov     [edx].IRQDesc.VID_Hw_Int_Proc,eax
                mov     [edx].IRQDesc.VID_Options,VPICD_OPT_CAN_SHARE
                mov     [edx].IsStolen,0
                mov     [edx].ValidIRQHandle,0
                mov     edi,edx
                add     edi,16
                push    edx
                push    esi
                VxDCall VPICD_Virtualize_IRQ
                pop     esi
                pop     edx
                jc      TryMethod2
                mov     [edx].IRQHandle,eax
                mov     [edx].ValidIRQHandle,1
                jmp     EndHookIRQ

        TryMethod2:
                ; Second method, steal a handle by calling
                ; VPICD_Get_IRQ_Complete_Status and picking up the address
                ; from code. Very very sleazy method, and it doesn't work!!!

                mov     eax,dword ptr[esi]
                push    eax
                push    edx
        FindCodeOffset:
                VxDCall VPICD_Get_IRQ_Complete_Status
                VxDCall VPICD_Get_Virtualization_Count
                pop     edx
                pop     eax
                mov     ecx,OFFSET32 FindCodeOffset
                mov     ecx,dword ptr[ecx+02h] ; Get pointer to address
                mov     ecx,dword ptr[ecx]     ; Get address
                mov     ecx,dword ptr[ecx+09h] ; Get pointer to handles array
                mov     ecx,dword ptr[ecx+eax*4] ; Get handle
                xchg    eax,ecx
                push    eax
                push    ecx
                push    edx
                VxDCall VPICD_Convert_Handle_To_IRQ
                pop     edx
                pop     ecx ; ECX = IRQ Number
                pop     eax ; EAX = IRQ Handle
                .if ecx==esi
                        mov     [edx].IRQHandle,eax
                        mov     [edx].IsStolen,1
                        mov     [edx].ValidIRQHandle,1
                        jmp     EndHookIRQ
                .else
                        ; SNOZZBERRY display error message
                .endif

        EndHookIRQ:

        .elseif [esi].dwIoControlCode==17

                ; Unhook IRQ

                mov     edx,MemBlock
                add     edx,8+sizeof DMAHandles
                assume  edx:ptr IRQBlock
                mov     esi,[esi].lpvInBuffer
                mov     ebx,dword ptr[esi]
                mov     eax,sizeof IRQBlock
                push    edx
                mul     ebx
                pop     edx
                add     edx,eax
                .if [edx].ValidIRQHandle!=0
                        mov     eax,[edx].IRQHandle
                        ; SNOZZBERRY check this function
                        push    edx
                        VxDCall VPICD_Force_Default_Behavior
                        pop     edx
                        mov     [edx].ValidIRQHandle,0
                        mov     [edx].IsStolen,0
                .else
                        ; SNOZZBERRY display error message: "tried to remove
                        ; non-existent IRQ handle"
                .endif

        .elseif [esi].dwIoControlCode==18

                ; Unconditionally close VM

                mov     eax,300 ; 300 millisecond time out
                mov     ebx,MyVMHandle
                xor     ecx,ecx
                VMMCall Close_VM

        .endif
        ret

EndProc OnDeviceIoControl 

BeginProc DosProc

        .if [ebp].Client_AX==1           ; Set VM handle, call init
                mov     MyVMHandle,ebx
                mov     eax,8000000h
                call    CallWin32
        .elseif [ebp].Client_AX==2       ; Close win32 app and VxD
                mov     CallParam,4000000h
                ; Just notify it, don't block the VM
                ;VxDCall _VWIN32_QueueUserApc, <ThreadProc,0,ThreadID>
                mov     eax,hSemaphore2
                VMMCall Signal_Semaphore
        .elseif [ebp].Client_AX==5       ; Call UserCreate callback
                mov     eax,5000000h
                call    CallWin32
        .elseif [ebp].Client_AX==6       ; Call UserDestroy callback
                mov     eax,6000000h
                call    CallWin32
        .elseif [ebp].Client_AX==0ffffh
                .if IsDone==0ffh
                        int 3
                .endif
        .endif
        
        ret

EndProc DosProc

BeginProc IOProc
        
        .if ecx==Byte_Output

                pushad
                inc     TotalOut

                .if dx==388h
                        mov     RegisterByte,al
                .elseif dx==389h
                        .if RegisterByte==02h                                
                                ; Set AdLib timer 1
                                and     eax,0ffh
                                mov     ebx,95
                                not     al
                                inc     eax
                                mul     ebx
                                mov     AdLibTimer1,eax
                                jmp     SkipCall1
                        .elseif RegisterByte==03h                                
                                ; Set AdLib timer 2
                                and     eax,0ffh
                                mov     ebx,382
                                not     al
                                inc     eax
                                mul     ebx
                                mov     AdLibTimer2,eax
                                jmp     SkipCall1
                        .elseif RegisterByte==04h                                
                                ; Set masks/start timer
                                and     eax,0ffh
                                test    al,80h
                                jz      NoTimerReset

                                ; Reset bits in status register
                                mov     TimerStatus,80h
                                jmp     SkipCall1

                        NoTimerReset:
                                test    al,1h
                                jz      NoTimer1Start
                                test    TimerStatus,1h
                                jnz     NoTimer1Start

                                ; Start timer 1
                                push    eax
                                VxDCall VTD_Get_Real_Time
                                mov     dword ptr[Timer1Start],eax
                                mov     dword ptr[Timer1Start+04h],edx
                                pop     eax
                                jmp     NoTimer2Start ; Skip things

                        NoTimer1Start:
                                test    al,2h
                                jz      NoTimer2Start
                                test    TimerStatus,2h
                                jnz     NoTimer2Start

                                ; Start timer 2
                                push    eax
                                VxDCall VTD_Get_Real_Time
                                mov     dword ptr[Timer2Start],eax
                                mov     dword ptr[Timer2Start+04h],edx
                                pop     eax

                        NoTimer2Start:
                                mov     TimerStatus,al
                                jmp     SkipCall1
                        .endif
                .endif                

                and     eax,0ffh
                shl     eax,16
                add     eax,1000000h
                mov     ax,dx
                call    CallWin32
        SkipCall1:
                popad

        .elseif ecx==Byte_Input

                pushad
                inc     TotalIn
                .if dx==388h                        
                        mov     cl,TimerStatus
                        mov     bl,cl
                        and     cl,41h ; Timer 1 status
                        and     bl,22h ; Timer 2 status
                        xor     si,si
                        VxDCall VTD_Get_Real_Time
                        push    eax
                        push    edx
                        sub     eax,dword ptr[Timer1Start]
                        sbb     edx,dword ptr[Timer1Start+04h]
                        .if cl==1h && (edx!=0 || eax > AdLibTimer1)
                                or      si,80h
                                or      si,40h
                        .endif
                        pop     edx
                        pop     eax
                        sub     eax,dword ptr[Timer2Start]
                        sbb     edx,dword ptr[Timer2Start+04h]
                        .if bl==2h && (edx!=0 || eax > AdLibTimer2)
                                or      si,80h
                                or      si,20h
                        .endif
                        mov     ax,si
                        mov     ReturnByte,al
                        jmp     SkipCall2
                .elseif dx==389h
                        mov     ReturnByte,0
                        jmp     SkipCall2
                .endif
                mov     eax,2000000h
                mov     ax,dx
                call    CallWin32
        SkipCall2:
                popad
                mov     al,ReturnByte

        .endif
        ret

EndProc IOProc

BeginProc DMAProc

        pushad
        mov     eax,3000000h
        call    CallWin32
        popad
        ret

EndProc DMAProc

BeginProc CallWin32

        mov     Acknowledge,0
        mov     CallParr2,eax
        mov     CallParam,eax
        mov     IsDone,0
        mov     eax,Cur_Run_VM_Boost
        mov     ebx,Win32VM
        xor     ecx,ecx
        xor     edx,edx
        mov     esi,OFFSET32 PriorityEventProc
        mov     edi,1000
        ;VMMCall Call_Priority_VM_Event
        mov     BigCountTemp,0
        ;cmp     IsDone,0ffh
        ;je      FunctionComplete
        ;mov     ebx,MyVMHandle
        ;VMMCall Suspend_VM
        ;mov     eax,-1
        ;VMMCall Time_Slice_Sleep
        mov     eax,hSemaphore2
        VMMCall Signal_Semaphore_No_Switch
        mov     eax,hSemaphore
        mov     ecx,Block_Thread_Idle
        VMMCall Wait_Semaphore
;CallLoop1:
;        cmp     IsDone,0ffh
;        je      FunctionComplete
;        inc     BigCountTemp
;        jmp     CallLoop1

FunctionComplete:
        mov     eax,BigCountTemp
        .if eax > BigCount
                mov     BigCount,eax
        .endif
        ret

EndProc CallWin32


BeginProc PriorityEventProc
        VxDCall _VWIN32_QueueUserApc, <ThreadProc,0,ThreadID>
        cld
        sti
        ret
EndProc PriorityEventProc

VxD_LOCKED_CODE_ENDS


end


